// Package abstract ...
//
// Description : abstract ...
//
// Author : go_developer@163.com<白茶清欢>
//
// Date : 2025-05-06 10:53
package abstract

// IJsonWrite json数据写入
type IJsonWrite interface {
	// Set 设置一个路径的值
	Set(dataPath string, data any) error
	// Result 最终结果以字符串形式返回
	Result() string
	// Map 最终结果以map返回
	Map() (map[string]any, error)
	// MapWithReceiver 外部指针接收返回值
	MapWithReceiver(receiver any) error
	// Array 最终结果以数组返回
	Array() ([]any, error)
	// ArrayWithReceiver 外部指针接收返回值
	ArrayWithReceiver(receiver any) error
}
